/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BaseElement } from "./BaseElement";
import { WCNativeHelper } from "./WCNativeHelper";
import { enumGetBox, markType } from "igniteui-react-core";
import { CarouselSlideType_$type } from "./CarouselSlideType";
import { CarouselSlideDirection_$type } from "./CarouselSlideDirection";
/**
 * @hidden
 */
var CarouselSlide = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CarouselSlide, _super);
    function CarouselSlide() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = new WCNativeHelper();
        _this.d = null;
        return _this;
    }
    Object.defineProperty(CarouselSlide.prototype, "b", {
        get: function () {
            return this.a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CarouselSlide.prototype, "nativeElement", {
        get: function () {
            return this.d;
        },
        set: function (a) {
            this.d = a;
            this.a.o = this.d;
        },
        enumerable: false,
        configurable: true
    });
    CarouselSlide.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(CarouselSlide.prototype, "c", {
        get: function () {
            var ret_ = this.b.n("active");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.b.w("active", value_);
        },
        enumerable: false,
        configurable: true
    });
    CarouselSlide.prototype.h = function (a, b) {
        this.nativeElement.toggleAnimation(this.b.i(enumGetBox(CarouselSlideType_$type, a)), this.b.i(enumGetBox(CarouselSlideDirection_$type, b)));
    };
    CarouselSlide.prototype.f = function () {
        this.nativeElement.connectedCallback();
    };
    CarouselSlide.$t = markType(CarouselSlide, 'CarouselSlide', BaseElement.$);
    return CarouselSlide;
}(BaseElement));
export { CarouselSlide };
