import { BaseElement } from "./BaseElement";
import { WCNativeHelper } from "./WCNativeHelper";
import { Type } from "igniteui-react-core";
import { CarouselIndicatorsOrientation } from "./CarouselIndicatorsOrientation";
import { CarouselAnimationType } from "./CarouselAnimationType";
import { NumberEventArgs } from "./NumberEventArgs";
import { VoidEventArgs } from "./VoidEventArgs";
import { CarouselAnimationDirection } from "./CarouselAnimationDirection";
/**
 * @hidden
 */
export declare class Carousel extends BaseElement {
    static $t: Type;
    private f;
    protected get g(): WCNativeHelper;
    private v;
    protected get nativeElement(): any;
    protected set nativeElement(a: any);
    setNativeElement(a: any): void;
    get h(): boolean;
    set h(a: boolean);
    get i(): boolean;
    set i(a: boolean);
    get k(): boolean;
    set k(a: boolean);
    get j(): boolean;
    set j(a: boolean);
    get q(): boolean;
    set q(a: boolean);
    get b(): CarouselIndicatorsOrientation;
    set b(a: CarouselIndicatorsOrientation);
    get x(): string;
    set x(a: string);
    get y(): string;
    set y(a: string);
    get s(): number;
    set s(a: number);
    get t(): number;
    set t(a: number);
    get a(): CarouselAnimationType;
    set a(a: CarouselAnimationType);
    get u(): number;
    get r(): number;
    get m(): boolean;
    get l(): boolean;
    slideChanged: (sender: any, args: NumberEventArgs) => void;
    slideChangedChanged(): void;
    playing: (sender: any, args: VoidEventArgs) => void;
    playingChanged(): void;
    paused: (sender: any, args: VoidEventArgs) => void;
    pausedChanged(): void;
    ab(): void;
    z(): void;
    n(): boolean;
    o(): boolean;
    p(a: number, b: CarouselAnimationDirection): boolean;
}
