/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BaseElement } from "./BaseElement";
import { WCNativeHelper } from "./WCNativeHelper";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { CarouselIndicatorsOrientation_$type } from "./CarouselIndicatorsOrientation";
import { CarouselAnimationType_$type } from "./CarouselAnimationType";
import { NumberEventArgs } from "./NumberEventArgs";
import { VoidEventArgs } from "./VoidEventArgs";
import { CarouselAnimationDirection_$type } from "./CarouselAnimationDirection";
/**
 * @hidden
 */
var Carousel = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Carousel, _super);
    function Carousel() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.f = new WCNativeHelper();
        _this.v = null;
        _this.slideChanged = null;
        _this.playing = null;
        _this.paused = null;
        return _this;
    }
    Object.defineProperty(Carousel.prototype, "g", {
        get: function () {
            return this.f;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Carousel.prototype, "nativeElement", {
        get: function () {
            return this.v;
        },
        set: function (a) {
            this.v = a;
            this.f.o = this.v;
        },
        enumerable: false,
        configurable: true
    });
    Carousel.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(Carousel.prototype, "h", {
        get: function () {
            var ret_ = this.g.n("disableLoop");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.w("disableLoop", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Carousel.prototype, "i", {
        get: function () {
            var ret_ = this.g.n("disablePauseOnInteraction");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.w("disablePauseOnInteraction", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Carousel.prototype, "k", {
        get: function () {
            var ret_ = this.g.n("hideNavigation");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.w("hideNavigation", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Carousel.prototype, "j", {
        get: function () {
            var ret_ = this.g.n("hideIndicators");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.w("hideIndicators", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Carousel.prototype, "q", {
        get: function () {
            var ret_ = this.g.n("vertical");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.w("vertical", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Carousel.prototype, "b", {
        get: function () {
            var ret_ = this.g.n("indicatorsOrientation");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(CarouselIndicatorsOrientation_$type, EnumUtil.getEnumValue(CarouselIndicatorsOrientation_$type, this.g.f(CarouselIndicatorsOrientation_$type, ret_)));
            return EnumUtil.getEnumValue(CarouselIndicatorsOrientation_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(CarouselIndicatorsOrientation_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.g.w("indicatorsOrientation", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Carousel.prototype, "x", {
        get: function () {
            var ret_ = this.g.n("indicatorsLabelFormat");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.w("indicatorsLabelFormat", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Carousel.prototype, "y", {
        get: function () {
            var ret_ = this.g.n("slidesLabelFormat");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.w("slidesLabelFormat", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Carousel.prototype, "s", {
        get: function () {
            var ret_ = this.g.n("interval");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.w("interval", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Carousel.prototype, "t", {
        get: function () {
            var ret_ = this.g.n("maximumIndicatorsCount");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.g.w("maximumIndicatorsCount", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Carousel.prototype, "a", {
        get: function () {
            var ret_ = this.g.n("animationType");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(CarouselAnimationType_$type, EnumUtil.getEnumValue(CarouselAnimationType_$type, this.g.f(CarouselAnimationType_$type, ret_)));
            return EnumUtil.getEnumValue(CarouselAnimationType_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(CarouselAnimationType_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.g.w("animationType", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Carousel.prototype, "u", {
        get: function () {
            var ret_ = this.g.n("total");
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Carousel.prototype, "r", {
        get: function () {
            var ret_ = this.g.n("current");
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Carousel.prototype, "m", {
        get: function () {
            var ret_ = this.g.n("isPlaying");
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Carousel.prototype, "l", {
        get: function () {
            var ret_ = this.g.n("isPaused");
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    Carousel.prototype.slideChangedChanged = function () {
        var _this = this;
        if (this.slideChanged != null) {
            this.g.s("slideChanged", function (a) { return _this.slideChanged(_this, NumberEventArgs.a(a)); });
        }
        else {
            this.g.v("slideChanged");
        }
    };
    Carousel.prototype.playingChanged = function () {
        var _this = this;
        if (this.playing != null) {
            this.g.s("playing", function (a) { return _this.playing(_this, VoidEventArgs.b(a)); });
        }
        else {
            this.g.v("playing");
        }
    };
    Carousel.prototype.pausedChanged = function () {
        var _this = this;
        if (this.paused != null) {
            this.g.s("paused", function (a) { return _this.paused(_this, VoidEventArgs.b(a)); });
        }
        else {
            this.g.v("paused");
        }
    };
    Carousel.prototype.ab = function () {
        this.nativeElement.play();
    };
    Carousel.prototype.z = function () {
        this.nativeElement.pause();
    };
    Carousel.prototype.n = function () {
        return (this.nativeElement.next());
    };
    Carousel.prototype.o = function () {
        return (this.nativeElement.prev());
    };
    Carousel.prototype.p = function (a, b) {
        return (this.nativeElement.select(this.g.i(a), this.g.i(enumGetBox(CarouselAnimationDirection_$type, b))));
    };
    Carousel.$t = markType(Carousel, 'Carousel', BaseElement.$);
    return Carousel;
}(BaseElement));
export { Carousel };
