import { BaseElement } from "./BaseElement";
import { WCNativeHelper } from "./WCNativeHelper";
import { Type } from "igniteui-react-core";
import { DockManagerLayout } from "./DockManagerLayout";
import { DockManagerPane } from "./DockManagerPane";
import { DockManagerPoint } from "./DockManagerPoint";
import { ContentPane } from "./ContentPane";
import { DockManagerShowHeaderIconOnHover } from "./DockManagerShowHeaderIconOnHover";
import { DockManagerResourceStrings } from "./DockManagerResourceStrings";
import { DockManagerShowPaneHeaders } from "./DockManagerShowPaneHeaders";
import { PaneActionBehavior } from "./PaneActionBehavior";
import { LayoutChangeEventArgs } from "./LayoutChangeEventArgs";
/**
 * @hidden
 */
export declare class DockManager extends BaseElement {
    static $t: Type;
    layoutChange: (sender: any, args: LayoutChangeEventArgs) => void;
    layoutChangeChanged(): void;
    private l;
    protected get m(): WCNativeHelper;
    private t;
    protected get nativeElement(): any;
    protected set nativeElement(a: any);
    setNativeElement(a: any): void;
    get b(): DockManagerLayout;
    set b(a: DockManagerLayout);
    get c(): DockManagerPane;
    set c(a: DockManagerPane);
    get e(): DockManagerPoint;
    set e(a: DockManagerPoint);
    get a(): ContentPane;
    set a(a: ContentPane);
    get p(): boolean;
    set p(a: boolean);
    get q(): boolean;
    set q(a: boolean);
    get g(): DockManagerShowHeaderIconOnHover;
    set g(a: DockManagerShowHeaderIconOnHover);
    get d(): DockManagerPane;
    set d(a: DockManagerPane);
    get f(): DockManagerResourceStrings;
    set f(a: DockManagerResourceStrings);
    get n(): boolean;
    set n(a: boolean);
    get r(): boolean;
    set r(a: boolean);
    get o(): boolean;
    set o(a: boolean);
    get h(): DockManagerShowPaneHeaders;
    set h(a: DockManagerShowPaneHeaders);
    get s(): boolean;
    set s(a: boolean);
    get j(): PaneActionBehavior;
    set j(a: PaneActionBehavior);
    get k(): PaneActionBehavior;
    set k(a: PaneActionBehavior);
    v(a: string): void;
}
